package cz.zweistein.df.soundsense.gui;

import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import cz.zweistein.df.soundsense.config.Sound;
import cz.zweistein.df.soundsense.config.SoundFile;
import cz.zweistein.df.soundsense.config.SoundsXML;

public class ConfigurationXMLTreeAdapter implements TreeModel {

	private SoundsXML config;

	public ConfigurationXMLTreeAdapter(SoundsXML config) {
		this.config = config;
	}

	@Override
	public void addTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Object getChild(Object parent, int index) {
		if (parent instanceof SoundsXML) {
			return ((SoundsXML)parent).getSounds().get(index);
		} else if (parent instanceof Sound) {
			return ((Sound)parent).getSoundFiles().get(index);
		} else {
			return null;
		}
	}

	@Override
	public int getChildCount(Object parent) {
		if (parent instanceof SoundsXML) {
			return ((SoundsXML)parent).getSounds().size();
		} else if (parent instanceof Sound) {
			return ((Sound)parent).getSoundFiles().size();
		} else {
			return 0;
		}
	}

	@Override
	public int getIndexOfChild(Object parent, Object child) {
		if (parent instanceof SoundsXML) {
			return ((SoundsXML)parent).getSounds().indexOf(child);
		} else if (parent instanceof Sound) {
			return ((Sound)parent).getSoundFiles().indexOf(child);
		} else {
			return 0;
		}
	}

	@Override
	public Object getRoot() {
		return config;
	}

	@Override
	public boolean isLeaf(Object node) {
		if (node instanceof SoundFile) {
			return true;
		} else if (node instanceof Sound) {
			if (((Sound)node).getSoundFiles().isEmpty()) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	@Override
	public void removeTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void valueForPathChanged(TreePath path, Object newValue) {
		// TODO Auto-generated method stub
		
	}

}
